// RC5 Sender auf 433MHz
// Alle Routinen zur Phasenmodulation
//
// Copyright 2000 by Holger Klabunde
// 02.06.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

#include "repeater.h" //Pindefinitionen
#include "protos.h"

//Im Gegensatz zu den Infrarot-Sendern brauche ich das
//Signal nicht mit 36kHz zu modulieren !
//Deshalb benutze ich den Timer fr die Impulsbreiten
//Der Code wird dadurch wesentlich kleiner

//Auerdem invertiert der Sender die Bits
//Dadurch knnen alle Empfnger statt eines IR-Empfngers
//einfach einen 433MHz Empfnger am Eingang benutzen.
//Ohne Programmnderung !!

//Auflsung des Timers 4 us
//RELOAD = 894us/4us = 223
//Wegen Programmoverhead krzer machen !

#define SENDDELAY	213     //Achtung DELAY gibts schon in phase.c !

//Eine 1 senden
void SendBit1()
{
 SENDER_ON(); //894us Impuls
 TMR0=0;    //Timer mit Abtastrate neu setzen
 while(TMR0<SENDDELAY); //Warten bis Timer berluft

 SENDER_OFF(); //894us Pause
 TMR0=0;    //Timer mit Abtastrate neu setzen
 while(TMR0<SENDDELAY); //Warten bis Timer berluft
}

//Eine 0 senden
void SendBit0()
{
 SENDER_OFF(); //894us Pause
 TMR0=0;    //Timer mit Abtastrate neu setzen
 while(TMR0<SENDDELAY); //Warten bis Timer berluft

 SENDER_ON();  //894us Impuls senden
 TMR0=0;    //Timer mit Abtastrate neu setzen
 while(TMR0<SENDDELAY); //Warten bis Timer berluft
}

void PhaseMod()
{
 unsigned char mask;     
 unsigned char i;
 
 CLRWDT;            //Laut Datenblatt vor ndern Prescaler fr TMR0
 OPTION=0b10000001; //Pullups off,Prescaler 1:4 und int. Clock	
                    //Ein TimerClock = 1us * 4 = 4us

//!!! Die Bits werden vom Sender invertiert !!!!

 SendBit1(); //Empfnger einschwingen
 SendBit1(); //Empfnger einschwingen

//Ein 1 Bit langes Sync senden. Danach sucht der Empfnger
//Der Empfnger erzeugt Rauschen wenn kein Trger steht
//Das erste Startbit wird dadurch oft als zweites Startbit erkannt 
 SENDER_ON();
 TMR0=0;    //Timer mit Abtastrate neu setzen
 while(TMR0<SENDDELAY); //Warten bis Timer berluft
 TMR0=0;    //Timer mit Abtastrate neu setzen
 while(TMR0<SENDDELAY); //Warten bis Timer berluft
 
 SendBit1(); //Erstes Startbit=1

//Fr Extended RC5 Startbit2=0 ermglichen
 if(comcode&0x40) SendBit0(); //Zweites Startbit=0
 else SendBit1();             //Zweites Startbit=1

//Togglebit
   if(toggle==0)
    {
     SendBit0();
    }
   else
    {
     SendBit1();
    }  
//Ende Togglebit

//5 Bit Gertecode
   mask=0x10; //Beginn bei MSB
   
   for(i=0; i<5; i++)
    {
     if(subcode&mask) //Send 1
      {
       SendBit1();
      }
     else //Send 0
      {
       SendBit0();
      }
      
     mask>>=1;   //Nchstes Bit
    }
//Ende Gertecode

//6 Bit Kommandocode
   mask=0x20; //Beginn bei MSB
   
   for(i=0; i<6; i++)
    {
     if(comcode&mask) //Send 1
      {
       SendBit1();
      }
     else //Send 0
      {
       SendBit0();
      }
     mask>>=1;  //Nchstes Bit
    }
//Ende Kommandocode

//bertragung komplett
   SENDER_OFF(); //Sender abschalten
//Nicht zu lange abschalten ! Sonst fngt der
//Empfnger wieder an zu rauschen.
}

